{{cookiecutter.project_name}}
==============================

{{cookiecutter.description}}


Project installation (Pre-requiresites)
---------------------------------------

We recommend to use ``pyenv`` for this project. If you do not have ``pyenv``, you can follow the instruction by using:

```
make help_setup
```

Alternatively, you can also use ``conda`` or ``venv``. You can check what is available for your system, by using:

```
make test_environment 
```


Project installation (with pyenv)
---------------------------------

1. create a pyenv environment (``pyenv virtualenv {{cookiecutter.python_version}} {{cookiecutter.repo_name}}``) and activate it locally (``pyenv activate {{cookiecutter.repo_name}}`` or ``pyenv local {{cookiecutter.repo_name}}``). We easy this install by using a Makefile command:

```
make create_pyenv_env
```

2. install the requirements (python depedencies/packages, etc.)

```
make dev-install
```

4. run the app with make run

```
make run
```

5. (optional) clean your environment with ``pyenv virtualenv-delete {cookiecutter.repo_name}}``. We easy this install by using a Makefile command:

```
make delete_pyenv_env
```


Project Organization
--------------------

    ├── LICENSE
    ├── Makefile           <- Makefile with commands like `make data` or `make train`
    ├── README.md          <- The top-level README for developers using this project.
    ├── data
    │   ├── external       <- Data from third party sources.
    │   ├── interim        <- Intermediate data that has been transformed.
    │   ├── processed      <- The final, canonical data sets for modeling.
    │   └── raw            <- The original, immutable data dump.
    │
    ├── docs               <- A default Sphinx project; see sphinx-doc.org for details
    │
    ├── models             <- Trained and serialized models, model predictions, or model summaries
    │
    ├── notebooks          <- Jupyter notebooks. Naming convention is a number (for ordering),
    │                         the creator's initials, and a short `-` delimited description, e.g.
    │                         `1.0-jqp-initial-data-exploration`.
    │
    ├── references         <- Data dictionaries, manuals, and all other explanatory materials.
    │
    ├── reports            <- Generated analysis as HTML, PDF, LaTeX, etc.
    │   └── figures        <- Generated graphics and figures to be used in reporting
    │
    ├── requirements.txt   <- The requirements file for reproducing the analysis environment, e.g.
    │                         generated with `pip freeze > requirements.txt`
    │
    ├── setup.py           <- makes project pip installable (pip install -e .) so src can be imported
    ├── src                <- Source code for use in this project.
    │   ├── __init__.py    <- Makes src a Python module
    │   │
    │   ├── data           <- Scripts to download or generate data
    │   │   └── make_dataset.py
    │   │
    │   ├── features       <- Scripts to turn raw data into features for modeling
    │   │   └── build_features.py
    │   │
    │   ├── models         <- Scripts to train models and then use trained models to make
    │   │   │                 predictions
    │   │   ├── predict_model.py
    │   │   └── train_model.py
    │   │
    │   └── visualization  <- Scripts to create exploratory and results oriented visualizations
    │       └── visualize.py
    │
    └── tox.ini            <- tox file with settings for running tox; see tox.readthedocs.io


--------

<p><small>Project based on the <a target="_blank" href="https://drivendata.github.io/cookiecutter-data-science/">cookiecutter data science project template</a>. #cookiecutterdatascience</small></p>
